
-- *************************************************
-- Opcik kezelse
-- *************************************************
TOptions = class(Turbine.Object);

pluginManagerForm = Turbine.UI.Control();
btnPMF1 = TButton(pluginManagerForm, "Open gear setup window", 100, 35, 200, 20);
pmfIkonForm = Turbine.UI.Control();
opIcoLeftSB = Turbine.UI.Lotro.ScrollBar();
opIcoTopSB = Turbine.UI.Lotro.ScrollBar();
opIcoLeftLabel = TLabel(pmfIkonForm,"Desktop icon left distance:", 50, 1, 300, 18);
opIcoTopLabel = TLabel(pmfIkonForm,"Desktop icon top distance:", 50, 1, 300, 18);
opCbYellowMode = Turbine.UI.Lotro.CheckBox();
opCbLoadMode = Turbine.UI.Lotro.CheckBox();
pmfSaveButton = TButton(pluginManagerForm,"Save the options",100,pluginManagerForm:GetHeight()-30,200,18);

-- Kontruktor
-- ===================================
function TOptions:Constructor()
	Turbine.Object.Constructor( self );
	self.icoLeft = 100;
	self.icoTop = 5;
	self.mainLeft = 50;
	self.mainTop = 20;
	self.activeItemSetName = "";
	self.charFileName = "BnyGearUpOptions";
--	self.serverFileName = "BnyGearUpSOptions";
	self.yellowMode = false;
	self.showIfLoad = false;
end

-- Feltlti adatokkal a struktrt
-- ===================================
function TOptions:LoadData()
	self:LoadState();
	if desktopIkonO ~= nil then
		desktopIkonO:SetPosition(self.icoLeft, self.icoTop);
	end
	if mainWindow ~= nil then
		mainWindow:SetPosition(self.mainLeft, self.mainTop);
	end
end

-- PluginData fjl beolvassa
-- ===================================
function TOptions:LoadState()
	debug("@TOptions:LoadState()");
	local obj = Turbine.Object();
	pcall(function() obj = PatchDataLoad( Turbine.DataScope.Character, self.charFileName)	end	);
	if obj ~= nil then
		if obj.icoLeft ~= nil then self.icoLeft = obj.icoLeft; end;
		if obj.icoTop ~= nil then self.icoTop = obj.icoTop; end;
		if obj.mainLeft ~= nil then self.mainLeft = obj.mainLeft; end;
		if obj.mainTop ~= nil then self.mainTop = obj.mainTop; end;
		if obj.activeItemSetName ~= nil then self.activeItemSetName = obj.activeItemSetName; end;
		if obj.yellowMode ~= nil then self.yellowMode = obj.yellowMode; end;
		if obj.showIfLoad ~= nil then self.showIfLoad = obj.showIfLoad; end;
	end
end

-- Adatok PluginData fjlba rsa
-- ===================================
function TOptions:SaveState()
	debug("@TOptions:SaveState()");
	local obj = Turbine.Object();
	obj.icoLeft = self.icoLeft;
	obj.icoTop = self.icoTop;
	obj.mainLeft = self.mainLeft;
	obj.mainTop = self.mainTop;
	obj.activeItemSetName = self.activeItemSetName;	
	obj.yellowMode = self.yellowMode;
	obj.showIfLoad = self.showIfLoad;
	pcall(function() PatchDataSave( Turbine.DataScope.Character, self.charFileName, obj) end);
end

-- Options panel ltrehozsa
-- ============================================
function TOptions:CreateOptionWindow()
	debug("@TOptions:CreateOptionWindow()");

	pluginManagerForm:SetSize(400,300);
	btnPMF1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	btnPMF1.Click = function() 
		pluginDataO:RepaintGearSetupWindow();
		opGearWindow:SetVisible(true);
		opGearWindow:Activate();
	end
	pmfIkonForm:SetSize(350,100);
	pmfIkonForm:SetParent(pluginManagerForm);
	pmfIkonForm:SetPosition(0, 50);
	local cY = 0;
		
	opIcoLeftLabel:SetText("Desktop icon left distance: " .. self.icoLeft .. "px");	
	opIcoLeftLabel:SetPosition(30, cY+20);
	opIcoLeftLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	opIcoLeftLabel:SetForeColor(Turbine.UI.Color(1, 1, 1));
	cY = opIcoLeftLabel:GetTop() + opIcoLeftLabel:GetHeight();
		
	opIcoLeftSB:SetPosition(30, cY);
	opIcoLeftSB:SetParent(pmfIkonForm);
	opIcoLeftSB:SetSize(250, 10);
	opIcoLeftSB:SetMaximum(Turbine.UI.Display:GetWidth()-desktopIkonO:GetWidth());
	opIcoLeftSB:SetValue(self.icoLeft);
	opIcoLeftSB.ValueChanged = function(s,a)
		opIcoLeftLabel:SetText("Desktop icon left distance: " .. opIcoLeftSB:GetValue() .. "px");
		self.icoLeft = opIcoLeftSB:GetValue();
		desktopIkonO:SetPosition(self.icoLeft,self.icoTop);
	end
	cY = opIcoLeftSB:GetTop() + opIcoLeftSB:GetHeight();
	
	opIcoTopLabel:SetText("Desktop icon top distance: " .. self.icoTop .. "px");	
	opIcoTopLabel:SetPosition(30, cY+10);
	opIcoTopLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	opIcoTopLabel:SetForeColor(Turbine.UI.Color(1, 1, 1));
	cY = opIcoTopLabel:GetTop() + opIcoTopLabel:GetHeight();
		
	opIcoTopSB:SetPosition(30, cY);
	opIcoTopSB:SetParent(pmfIkonForm);
	opIcoTopSB:SetSize(250,10);
	opIcoTopSB:SetMaximum(Turbine.UI.Display:GetHeight()-desktopIkonO:GetHeight());
	opIcoTopSB:SetValue(self.icoTop);
	opIcoTopSB.ValueChanged = function(s,a)
		opIcoTopLabel:SetText("Desktop icon top distance: " .. opIcoTopSB:GetValue() .. "px");
		self.icoTop = opIcoTopSB:GetValue();
		desktopIkonO:SetPosition(self.icoLeft,self.icoTop);
	end
	cY = pmfIkonForm:GetTop() + pmfIkonForm:GetHeight();
	
	opCbYellowMode:SetPosition(30,cY);
	opCbYellowMode:SetSize(350, 18);
	opCbYellowMode:SetText(" Enable yellow (warning) desktop icon phase.");
	opCbYellowMode:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	opCbYellowMode:SetForeColor(Turbine.UI.Color(1,1,1));
	opCbYellowMode:SetParent(pluginManagerForm);
	opCbYellowMode:SetChecked(self.yellowMode);
	-- cb vltozik
	opCbYellowMode.CheckedChanged = function (sender, args) 
		self.yellowMode=sender:IsChecked();
	end;
	cY = opCbYellowMode:GetTop() + opCbYellowMode:GetHeight();
	
	opCbLoadMode:SetPosition(30, cY+5);
	opCbLoadMode:SetSize(350, 18);
	opCbLoadMode:SetText(" Show main window when plugin load.");
	opCbLoadMode:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	opCbLoadMode:SetForeColor(Turbine.UI.Color(1,1,1));
	opCbLoadMode:SetParent(pluginManagerForm);
	opCbLoadMode:SetChecked(self.showIfLoad);
	-- cb vltozik
	opCbLoadMode.CheckedChanged = function (sender, args) 
		self.showIfLoad=sender:IsChecked();
	end;
	cY = opCbLoadMode:GetTop() + opCbLoadMode:GetHeight();
		
	pluginManagerForm:SetHeight(cY + 50);
	pmfSaveButton:SetTop(pluginManagerForm:GetHeight()-30);
	pmfSaveButton.Click = function()
		self:SaveState();
	end

end
